import 'package:flutter/services.dart';

class Admost {
  /// Starts Admost mediation and analytics functions, it must be called at the very beginning of the application life cycle
  /// appId : Application id got from Admost dashboard
  String appId;
  String userConsent;
  String subjectToGDPR;
  String subjectToCCPA;
  Admost.initialize(Map<String, String> config) {
    MethodChannel _channel = const MethodChannel('admost_flutter');

    if (config.containsKey('appId')){
      appId = config['appId'];
    }else{
      config["appId"] = "";
      print("appId is missing!");
    }

    _channel.invokeMethod('initialize', config);
  }

  /// Opens up test screen for ad network testing, available only for testers
  /// To be tester, Google Advertising Id has to be entered in the Admost Dashboard Testers screen
  Admost.startTestSuite() {
    MethodChannel _channel = const MethodChannel('admost_flutter');
    _channel.invokeMethod('startTestSuite');
  }
}
